page    ,133
%title  "Activity 6 Test Program"
comment *
Ŀ
 From "Build Your Own Computer: How to Construct an 8088 Based             
       Single Board Microcomputer" by Walter Fuller  (c)1995 Delmar        

*
.model tiny

.code
        org     8000h                   ;this location is the start of EPROM

main    proc
        
        mov     sp,1000h                ;put stack in low RAM - but not low
                                        ;enough to mess up interrupt vector
                                        ;table
        mov     bp,0
        mov     si,0
        mov     di,0

        mov     dx,offset type1         ;set up interrupt vector table
        mov     si,0004h                ;type 1 int vector is at 0004H
        mov     word ptr[si],dx         ;store offset
        add     si,2                    ;point to segment location in table
        mov     word ptr[si],0          ;store CS address (always 0)

        call    set_tflag               ;set the T flag

again:        
        out     50h,al                  ;now give the processor something
        jmp     again                   ;to do

main    endp

set_tflag       proc        
        pushf                           ;put flags on stack
        mov     bp,sp                   ;use bp to point to them
        or      byte ptr[bp+1],1        ;set T flag while still on stack
        popf                            ;now put new flags in flag register
        ret
set_tflag       endp

type1   proc
        wait                            ;wait for TEST input to go to 0
        iret                            ;resume processing
type1   endp

        org     0fff0h

        db      0eah,0,80h,0,0          ;do far jump to 0000:8000                   
                                        ;processor starts here - so send
                                        ;it down to 8000h where there is
                                        ;room to do something

        end     main
