.model tiny

.code

        ;This is the activity 8 test program

ppi_1_port_a  equ     24h
ppi_1_port_b  equ     25h
ppi_1_port_c  equ     26h
ppi_1_ctrl    equ     27h

ppi_2_port_a  equ     28h
ppi_2_port_b  equ     29h
ppi_2_port_c  equ     2ah
ppi_2_ctrl    equ     2bh

        org     8000h
        
main    proc

        mov     al,10000000b    ;configuration word for the 8255
                                ;both group A and B = mode 0
                                ;port A = input
                                ;port B = output
                                ;port C = input

        out     ppi_1_ctrl,al         ;send the configuration word 
        out     ppi_2_ctrl,al         ;to both 8255s

again:
        mov     al,0            ;all port B lines to logic low
        out     ppi_1_port_a,al
        out     ppi_1_port_b,al
        out     ppi_1_port_c,al
        out     ppi_2_port_a,al
        out     ppi_2_port_b,al
        out     ppi_2_port_c,al



        mov     al,0ffh         ;now all port B lines to logic high
        out     ppi_1_port_a,al
        out     ppi_1_port_b,al
        out     ppi_1_port_c,al
        out     ppi_2_port_a,al
        out     ppi_2_port_b,al
        out     ppi_2_port_c,al
        
        jmp     again           ;keep doing this forever

main    endp

        org     0fff0h

        db      0eah,0,80h,0,0  ;opcodes for far jump to 08000h
                                ;go there to start program

end    main
        

